<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;tock-registers-0.7.0&#x2F;src&#x2F;local_register.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>local_register.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../tock_registers/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
</pre><pre class="rust"><code><span class="doccomment">//! Module containing the [`LocalRegisterCopy`] type. Please refer to</span>
<span class="doccomment">//! its documentation.</span>

<span class="kw">use</span> <span class="ident">core::fmt</span>;
<span class="kw">use</span> <span class="ident">core::marker::PhantomData</span>;

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::fields</span>::{<span class="ident">Field</span>, <span class="ident">FieldValue</span>, <span class="ident">TryFromValue</span>};
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">RegisterLongName</span>, <span class="ident">UIntLike</span>};

<span class="doccomment">/// A read-write copy of register contents.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This behaves very similarly to a read-write register, but instead of doing a</span>
<span class="doccomment">/// volatile read to MMIO to get the value for each function call, a copy of the</span>
<span class="doccomment">/// register contents are stored locally in memory. This allows a peripheral</span>
<span class="doccomment">/// to do a single read on a register, and then check which bits are set without</span>
<span class="doccomment">/// having to do a full MMIO read each time. It also allows the value of the</span>
<span class="doccomment">/// register to be &quot;cached&quot; in case the peripheral driver needs to clear the</span>
<span class="doccomment">/// register in hardware yet still be able to check the bits.</span>
<span class="doccomment">/// You can write to a local register, which will modify the stored value, but</span>
<span class="doccomment">/// will not modify any hardware because it operates only on local copy.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This type does not implement the</span>
<span class="doccomment">/// [`Readable`](crate::interfaces::Readable) and</span>
<span class="doccomment">/// [`Writeable`](crate::interfaces::Writeable) traits because it</span>
<span class="doccomment">/// requires a mutable reference to modify the contained value. It</span>
<span class="doccomment">/// still mirrors the interface which would be exposed by a type</span>
<span class="doccomment">/// implementing [`Readable`](crate::interfaces::Readable),</span>
<span class="doccomment">/// [`Writeable`](crate::interfaces::Writeable) and</span>
<span class="doccomment">/// [`ReadWriteable`](crate::interfaces::ReadWriteable).</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">UIntLike</span>, <span class="ident">R</span>: <span class="ident">RegisterLongName</span> <span class="op">=</span> ()<span class="op">&gt;</span> {
    <span class="ident">value</span>: <span class="ident">T</span>,
    <span class="ident">associated_register</span>: <span class="ident">PhantomData</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">UIntLike</span>, <span class="ident">R</span>: <span class="ident">RegisterLongName</span><span class="op">&gt;</span> <span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">value</span>: <span class="ident">T</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">LocalRegisterCopy</span> {
            <span class="ident">value</span>: <span class="ident">value</span>,
            <span class="ident">associated_register</span>: <span class="ident">PhantomData</span>,
        }
    }

    <span class="doccomment">/// Get the raw register value</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">T</span> {
        <span class="self">self</span>.<span class="ident">value</span>
    }

    <span class="doccomment">/// Set the raw register value</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">value</span>: <span class="ident">T</span>) {
        <span class="self">self</span>.<span class="ident">value</span> <span class="op">=</span> <span class="ident">value</span>;
    }

    <span class="doccomment">/// Read the value of the given field</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">read</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="ident">Field</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">T</span> {
        <span class="ident">field</span>.<span class="ident">read</span>(<span class="self">self</span>.<span class="ident">get</span>())
    }

    <span class="doccomment">/// Read value of the given field as an enum member</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">read_as_enum</span><span class="op">&lt;</span><span class="ident">E</span>: <span class="ident">TryFromValue</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">EnumType</span> <span class="op">=</span> <span class="ident">E</span><span class="op">&gt;</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="ident">Field</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">E</span><span class="op">&gt;</span> {
        <span class="ident">field</span>.<span class="ident">read_as_enum</span>(<span class="self">self</span>.<span class="ident">get</span>())
    }

    <span class="doccomment">/// Write the value of one or more fields, overwriting the other fields with zero</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">field</span>: <span class="ident">FieldValue</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">set</span>(<span class="ident">field</span>.<span class="ident">value</span>);
    }

    <span class="doccomment">/// Write the value of one or more fields, leaving the other fields unchanged</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">modify</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">field</span>: <span class="ident">FieldValue</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) {
        <span class="self">self</span>.<span class="ident">set</span>(<span class="ident">field</span>.<span class="ident">modify</span>(<span class="self">self</span>.<span class="ident">get</span>()));
    }

    <span class="doccomment">/// Check if one or more bits in a field are set</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_set</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="ident">Field</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="ident">field</span>.<span class="ident">is_set</span>(<span class="self">self</span>.<span class="ident">get</span>())
    }

    <span class="doccomment">/// Check if any specified parts of a field match</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matches_any</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="ident">FieldValue</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="ident">field</span>.<span class="ident">matches_any</span>(<span class="self">self</span>.<span class="ident">get</span>())
    }

    <span class="doccomment">/// Check if all specified parts of a field match</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">matches_all</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">field</span>: <span class="ident">FieldValue</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="ident">field</span>.<span class="ident">matches_all</span>(<span class="self">self</span>.<span class="ident">get</span>())
    }

    <span class="doccomment">/// Do a bitwise AND operation of the stored value and the passed in value</span>
    <span class="doccomment">/// and return a new LocalRegisterCopy.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">bitand</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rhs</span>: <span class="ident">T</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span> {
        <span class="ident">LocalRegisterCopy::new</span>(<span class="self">self</span>.<span class="ident">value</span> <span class="op">&amp;</span> <span class="ident">rhs</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">UIntLike</span> <span class="op">+</span> <span class="ident">fmt::Debug</span>, <span class="ident">R</span>: <span class="ident">RegisterLongName</span><span class="op">&gt;</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">R</span><span class="op">&gt;</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">fmt::Formatter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">fmt::Result</span> {
        <span class="macro">write!</span>(<span class="ident">f</span>, <span class="string">&quot;{:?}&quot;</span>, <span class="self">self</span>.<span class="ident">value</span>)
    }
}

<span class="comment">// Helper macro to implement From&lt;LocalRegisterCopy&lt;T: UIntLike&gt;, R&gt;&gt;</span>
<span class="comment">// for &lt;T: UIntLike&gt;</span>
<span class="macro">macro_rules!</span> <span class="ident">From_impl_for</span> {
    (<span class="macro-nonterminal">$</span><span class="kw">type</span>:<span class="macro-nonterminal">ty</span>) <span class="op">=</span><span class="op">&gt;</span> {
        <span class="kw">impl</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">RegisterLongName</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="kw">type</span>, <span class="macro-nonterminal">R</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="macro-nonterminal">$</span><span class="kw">type</span> {
            <span class="kw">fn</span> <span class="macro-nonterminal">from</span>(<span class="ident">r</span>: <span class="ident">LocalRegisterCopy</span><span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="kw">type</span>, <span class="macro-nonterminal">R</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="kw">type</span> {
                <span class="macro-nonterminal">r</span>.<span class="ident">value</span>
            }
        }
    };
}

<span class="macro">From_impl_for!</span>(<span class="ident">u8</span>);
<span class="macro">From_impl_for!</span>(<span class="ident">u16</span>);
<span class="macro">From_impl_for!</span>(<span class="ident">u32</span>);
<span class="macro">From_impl_for!</span>(<span class="ident">u64</span>);
<span class="macro">From_impl_for!</span>(<span class="ident">u128</span>);
<span class="macro">From_impl_for!</span>(<span class="ident">usize</span>);
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="tock_registers" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>